Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.cpp	(revision 30544)
@@ -111,9 +111,10 @@
 
 UIMachineView* UIMachineView::create(  UIMachineWindow *pMachineWindow
+                                     , ulong uScreenId
+                                     , UIVisualStateType visualStateType
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                      , bool bAccelerate2DVideo
 #endif
-                                     , UIVisualStateType visualStateType
-                                     , ulong uScreenId)
+                                     )
 {
     UIMachineView *view = 0;
@@ -122,22 +123,25 @@
         case UIVisualStateType_Normal:
             view = new UIMachineViewNormal(  pMachineWindow
+                                           , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                            , bAccelerate2DVideo
 #endif
-                                           , uScreenId);
+                                           );
             break;
         case UIVisualStateType_Fullscreen:
             view = new UIMachineViewFullscreen(  pMachineWindow
+                                               , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                                , bAccelerate2DVideo
 #endif
-                                               , uScreenId);
+                                               );
             break;
         case UIVisualStateType_Seamless:
             view = new UIMachineViewSeamless(  pMachineWindow
+                                             , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                              , bAccelerate2DVideo
 #endif
-                                             , uScreenId);
+                                             );
             break;
         default:
@@ -147,7 +151,7 @@
 }
 
-void UIMachineView::destroy(UIMachineView *pWhichView)
-{
-    delete pWhichView;
+void UIMachineView::destroy(UIMachineView *pMachineView)
+{
+    delete pMachineView;
 }
 
@@ -159,10 +163,9 @@
 
 UIMachineView::UIMachineView(  UIMachineWindow *pMachineWindow
+                             , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                              , bool bAccelerate2DVideo
 #endif
-                             , ulong uScreenId)
-// TODO_NEW_CORE: really think of if this is right
-//    : QAbstractScrollArea(((QMainWindow*)pMachineWindow->machineWindow())->centralWidget())
+                             )
     : QAbstractScrollArea(pMachineWindow->machineWindow())
     , m_pMachineWindow(pMachineWindow)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/UIMachineView.h	(revision 30544)
@@ -48,12 +48,14 @@
     enum DesktopGeo { DesktopGeo_Invalid = 0, DesktopGeo_Fixed, DesktopGeo_Automatic, DesktopGeo_Any };
 
-    /* Factory function to create required view sub-child: */
+    /* Factory function to create machine-view: */
     static UIMachineView* create(  UIMachineWindow *pMachineWindow
+                                 , ulong uScreenId
+                                 , UIVisualStateType visualStateType
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                  , bool bAccelerate2DVideo
 #endif
-                                 , UIVisualStateType visualStateType
-                                 , ulong uScreenId);
-    static void destroy(UIMachineView *pWhichView);
+    );
+    /* Factory function to destroy required machine-view: */
+    static void destroy(UIMachineView *pMachineView);
 
     /* Public getters: */
@@ -77,10 +79,12 @@
 protected:
 
-    /* Machine view constructor/destructor: */
+    /* Machine-view constructor: */
     UIMachineView(  UIMachineWindow *pMachineWindow
+                  , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                   , bool bAccelerate2DVideo
 #endif
-                  , ulong uScreenId);
+    );
+    /* Machine-view destructor: */
     virtual ~UIMachineView();
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.cpp	(revision 30544)
@@ -41,13 +41,15 @@
 
 UIMachineViewFullscreen::UIMachineViewFullscreen(  UIMachineWindow *pMachineWindow
+                                                 , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                                  , bool bAccelerate2DVideo
 #endif
-                                                 , ulong uMonitor)
+                                                 )
     : UIMachineView(  pMachineWindow
+                    , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                     , bAccelerate2DVideo
 #endif
-                    , uMonitor)
+                    )
     , m_bIsGuestAutoresizeEnabled(pMachineWindow->machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize)->isChecked())
     , m_fShouldWeDoResize(false)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.h	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineViewFullscreen.h	(revision 30544)
@@ -29,10 +29,12 @@
 protected:
 
-    /* Fullscreen machine-view constructor/destructor: */
+    /* Fullscreen machine-view constructor: */
     UIMachineViewFullscreen(  UIMachineWindow *pMachineWindow
+                            , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                             , bool bAccelerate2DVideo
 #endif
-                            , ulong uMonitor);
+    );
+    /* Fullscreen machine-view destructor: */
     virtual ~UIMachineViewFullscreen();
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/fullscreen/UIMachineWindowFullscreen.cpp	(revision 30544)
@@ -219,9 +219,10 @@
 
     m_pMachineView = UIMachineView::create(  this
+                                           , m_uScreenId
+                                           , machineLogic()->visualStateType()
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                            , bAccelerate2DVideo
 #endif
-                                           , machineLogic()->visualStateType()
-                                           , m_uScreenId);
+                                           );
 
     /* Add machine view into layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.cpp	(revision 30544)
@@ -36,13 +36,15 @@
 
 UIMachineViewNormal::UIMachineViewNormal(  UIMachineWindow *pMachineWindow
+                                         , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                          , bool bAccelerate2DVideo
 #endif
-                                         , ulong uMonitor)
+                                         )
     : UIMachineView(  pMachineWindow
+                    , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                     , bAccelerate2DVideo
 #endif
-                    , uMonitor)
+                    )
     , m_bIsGuestAutoresizeEnabled(pMachineWindow->machineLogic()->actionsPool()->action(UIActionIndex_Toggle_GuestAutoresize)->isChecked())
     , m_fShouldWeDoResize(false)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.h	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineViewNormal.h	(revision 30544)
@@ -29,10 +29,12 @@
 protected:
 
-    /* Normal machine-view constructor/destructor: */
+    /* Normal machine-view constructor: */
     UIMachineViewNormal(  UIMachineWindow *pMachineWindow
+                        , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                         , bool bAccelerate2DVideo
 #endif
-                        , ulong uMonitor);
+    );
+    /* Normal machine-view destructor: */
     virtual ~UIMachineViewNormal();
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/normal/UIMachineWindowNormal.cpp	(revision 30544)
@@ -480,9 +480,10 @@
 
     m_pMachineView = UIMachineView::create(  this
+                                           , m_uScreenId
+                                           , machineLogic()->visualStateType()
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                            , bAccelerate2DVideo
 #endif
-                                           , machineLogic()->visualStateType()
-                                           , m_uScreenId);
+                                           );
 
     /* Add machine view into layout: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.cpp	(revision 30544)
@@ -40,13 +40,15 @@
 
 UIMachineViewSeamless::UIMachineViewSeamless(  UIMachineWindow *pMachineWindow
+                                             , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                              , bool bAccelerate2DVideo
 #endif
-                                             , ulong uMonitor)
+                                             )
     : UIMachineView(  pMachineWindow
+                    , uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                     , bAccelerate2DVideo
 #endif
-                    , uMonitor)
+                    )
     , m_fShouldWeDoResize(false)
     , m_pSyncBlocker(0)
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.h	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineViewSeamless.h	(revision 30544)
@@ -29,10 +29,12 @@
 protected:
 
-    /* Seamless machine-view constructor/destructor: */
+    /* Seamless machine-view constructor: */
     UIMachineViewSeamless(  UIMachineWindow *pMachineWindow
+                          , ulong uScreenId
 #ifdef VBOX_WITH_VIDEOHWACCEL
                           , bool bAccelerate2DVideo
 #endif
-                          , ulong uMonitor);
+    );
+    /* Seamless machine-view destructor: */
     virtual ~UIMachineViewSeamless();
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 30543)
+++ trunk/src/VBox/Frontends/VirtualBox/src/runtime/seamless/UIMachineWindowSeamless.cpp	(revision 30544)
@@ -270,9 +270,10 @@
 
     m_pMachineView = UIMachineView::create(  this
+                                           , m_uScreenId
+                                           , machineLogic()->visualStateType()
 #ifdef VBOX_WITH_VIDEOHWACCEL
                                            , bAccelerate2DVideo
 #endif
-                                           , machineLogic()->visualStateType()
-                                           , m_uScreenId);
+                                           );
 
     /* Add machine view into layout: */